import processing.core.*; import processing.phone.*; public class image_pan extends PMIDlet{/*  30th June 2006. UIAV Venice mobile services workshop. 
    By Vinay Venkatraman & David Mellis 
    This code will load an image file and let you pan with arrow keys 
    Pressing Ok/Confirm will reset the image to home position 
    Pressing 0 Key will exit the program since softkey by deafult does not appear in fullscreen mode
    Tested on a Nokia 6630 Phone only 
*/

     // import phone library to go full screen

PImage b; 
Phone p;
int x=0;                       // Image initial position_X
int y=0;                       // Image initial position_Y 
int img_width;                 // Image width 
int img_height;                // Image height
int pan_speed = 10;            // Set pan speed ( 8 to 10 is a good speed)
String filename ="metro.png";  // Select image file


public void setup()
{
  size(176, 208);              // Set the screen size for Nokia 6630
  b = loadImage(filename);     // Load a PNG Image larger than screen 
  img_width = b.width;         // Set the image width from file
  img_height = b.height;       // Set the image height from file
  p = new Phone(this);
  p.fullscreen();              // Go full screen 
  
}

// This gets called (once) when a key is pressed.
public void keyPressed() 
{
  if (keyCode == FIRE) {
    x=0;                       // Reset Image position to home
    y=0;
  } else if(keyCode == '0') { 
    exit();                    // Exit the program 
  } 
     
}


public void draw() {
  
  
  // this is true as long as a key is still held down.
  if(keyPressed)
  { 
    // Make sure this is within the main draw loop to get continous pan on keypress.
    // Otherwise, you would need to press the keys over and over to move.
    
    if(keyCode == DOWN){
      y=y-pan_speed; }                // Pan up 
    else if (keyCode == UP){
      y=y+pan_speed;}                 // Pan down 
    else if (keyCode == RIGHT){
      x=x-pan_speed;}                 // Pan left 
    else if (keyCode == LEFT) {
      x=x+pan_speed;}                 // Pan right  
    
    x = constrain(x,(width-img_width),0);   // Prevent image from panning beyond width
    y = constrain(y,(height-img_height),0); // Prevent image from panning beyond height
    
    
  }
  
   
  image(b, x, y);              // Display image
  
  
}

}